package cse425s.hw2;
import cse425s.hw2.syntax.*;
import java.io.*;

public class Main
{
    public static void main(String[] args){
            switch(args.length){
                case 0: 
                            runInInteractiveMode(); 
                            break;
                case 1:
                            if ( args[0].equalsIgnoreCase("h") || args[0].equalsIgnoreCase("-h") || args[0].equalsIgnoreCase("--help") || args[0].equals("?") || args[0].equals("-?") ){
                                displayHelp();
                            }else if ( args[0].equalsIgnoreCase("v") || args[0].equalsIgnoreCase("-v") || args[0].equalsIgnoreCase("version")  || args[0].equalsIgnoreCase("-version")  || args[0].equalsIgnoreCase("--version") ){
                                displayVersion();
                            }else if ( args[0].equalsIgnoreCase("--version-triplet") ){
                                displayVersionTriplet();
                            }else if ( args[0].equalsIgnoreCase("-i") || args[0].equalsIgnoreCase("--i") || args[0].equalsIgnoreCase("-interactive") || args[0].equalsIgnoreCase("--interactive") ){
                                runInInteractiveMode();
                            }else{
                                run(args[0],"stdout");
                            }
                            break;
                case 2:
                            run(args[0],args[1]);
                            break;
                default:
                            displayHelp();
                            System.exit(1);
            }
    }
    
    public static void displayHelp(){
        System.out.println("Usage:");
        System.out.println("            java -jar "+ getJarName() +" [ --interactive | --help | --version ]");
        System.out.println("            java -jar "+ getJarName() +" <input>");
        System.out.println("            java -jar "+ getJarName() +" <input> <output>");
    }
    
    public static String getJarName(){
        if ( _name_of_jar_file == null ){
            try{
                File jarFile = new File(cse425s.hw2.Main.class.getProtectionDomain().getCodeSource().getLocation().toURI());
                _name_of_jar_file = jarFile.getName();
            }catch(Exception error){
                return "<name_of_jar_file>";
            }
        }
        return _name_of_jar_file;
    }
    
    public static void displayVersion(){
        Application a = new Interpreter();
        System.out.println(a.getApplicationName() + " v"+a.getApplicationVersion());
        System.out.println(a.getApplicationAuthor() + "; Copyright (C) "+a.getApplicationYear());
    }
    
    public static void displayVersionTriplet(){
        Application a = new Interpreter();
        System.out.println(a.getApplicationVersion());
    }
    
    public static void runInInteractiveMode(){
        try{
            Parser      p = new DefaultParser(new DefaultLexer(new DefaultScanner("stdin",true)));
            Interpreter i = new Interpreter(System.out);
            
            boolean done=false;
            do{
                try{
                    i.interpret(p.read());
                }catch(EOFException outofstatements){
                    done=true;
                }
            }while(!done);
            
            
        }catch(Exception e){
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public static void run(String input, String output){
        try{
            Parser      p = new DefaultParser(new DefaultLexer(new DefaultScanner(input,false)));
            PrintStream o = ((output.equals("-")||output.equalsIgnoreCase("stdout"))? (System.out) : (new PrintStream(new BufferedOutputStream(new FileOutputStream(output)))));
            Interpreter i = new Interpreter(o);
            
            boolean done=false;
            do{
                try{
                    i.interpret(p.read());
                }catch(EOFException outofstatements){
                    done=true;
                }
            }while(!done);
            
            if ( o != System.out ){
                o.close();
            }
            
        }catch(Exception e){
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    static String _name_of_jar_file = null;
}
