package cse425s.hw2.syntax;
import java.io.*;
import java.net.URL;

public class DefaultScanner implements Scanner
{
    public DefaultScanner(String resource) throws IOException {
        this(resource,(resource.equals("-") || resource.equalsIgnoreCase("stdin")));
    }
    
    public DefaultScanner(String resource, boolean prompt) throws IOException {
        _resourcename = resource;
        if ( resource.equals("-") || resource.equalsIgnoreCase("stdin") ){
            _reader = new BufferedReader(new InputStreamReader(System.in));
        }else if ( resource.startsWith("http://") || resource.startsWith("https://") ){
            _reader = new BufferedReader(new InputStreamReader((new URL(resource)).openStream()));
        }else{
            _reader = new BufferedReader(new InputStreamReader(new FileInputStream(resource)));
        }
        _prompt = prompt;
        _line   = 0;
        _offset = 0;
        _string = null;
    }
    
    public String getFileName(){
        return _resourcename;
    }
    
    public int getLineNumber(){
        return _line;
    }
    
    public int getLineOffset(){
        return _offset;
    }
    
    public char peek() throws IOException {
        if ( (_string==null) || (_offset>=_string.length()) ){
            if ( _prompt ){
                System.out.print(">> ");
            }
            String str=_reader.readLine();
            if ( str == null ){
                throw new EOFException();
            }else{
                _string = str + "\n";
            }
            _line++;
            _offset = 0;
        }
        return ((_string==null)?('\0'):(_string.charAt(_offset)));
    }
    
    public char read() throws IOException {
        char result=peek();
        _offset++;
        return result;
    }
    
    
    private String _resourcename;
    private BufferedReader _reader;
    private boolean _prompt;
    private int _line;
    private int _offset;
    private String _string;
}
