package cse425s.hw2.syntax.statement;
import java.util.Collection;

public class DefineStatement implements Statement
{
    public DefineStatement(String classname, Collection<String> parents, Collection<String> passwords, Collection<String> capabilities){
        _classname = classname;
        _parents   = parents;
        _passwords = passwords;
        _capabilities = capabilities;
    }
    
    public String getDefinedClassName(){
        return _classname;
    }
    
    public Collection<String> getBaseClassNames(){
        return _parents;
    }
    
    public Collection<String> getRequiredPasswords(){
        return _passwords;
    }
    
    public Collection<String> getProvidedCapabilities(){
        return _capabilities;
    }
    
    public String toString(){
        StringBuilder sb = new StringBuilder();
        sb.append("define");
        sb.append(" ");
        sb.append(_classname);
        
        String[] keywords = { "inherits", "passwords", "capabilities" };
        Collection[] collections = { _parents, _passwords, _capabilities };
        
        for ( int i = 0; i< keywords.length; i++ ){
            if ( collections[i].size() > 0 ){
                sb.append(" ");
                sb.append(keywords[i]);
                boolean notfirst=false;
                for ( Object entry : collections[i] ){
                    if ( notfirst ){
                        sb.append(", ");
                        sb.append(entry.toString());
                    }else{
                        sb.append(" ");
                        sb.append(entry.toString());
                        notfirst=true;
                    }
                }
            }
        }
        
        sb.append(";");
        return sb.toString();
    }
    
    private String _classname;
    private Collection<String> _parents;
    private Collection<String> _passwords;
    private Collection<String> _capabilities;
}
